#!/bin/bash
#
# X10 Remotecontrol install script
# (CC) BY-NC-SA by speefak
#
########################
### define variables ### 
########################

CODENAME=$(lsb_release -c | tr -d : | cut -f 2)

if [ "$(grep "ati_remote" /etc/modprobe.d/blacklist.conf)" = "blacklist ati_remote" ]   ;then	# Set Blacklist variable for ati_remote module
        ATIBL=yes      ;else
        ATIBL=no
fi

if [ "$(grep "lirc_dev" /etc/rc.local)" = "sudo modprobe lirc_dev" ]   ;then			# rc.local autoload X10 Remote Driver 
        RMRCL=yes      ;else
        RMRCL=no
fi



########################
### define functions ###
########################

function LIRCINST ()									# X 10 Remote Software and XBMC installation
{
	echo
	echo
	echo "Packetconfiguration for X10 Remote -> choose >> ATI/NVidia X10 RF (userspace) <<"
	echo "In the follwing dialog choose >> None << "
	echo
	echo Press any key to continue
	read
	sudo apt-get install lirc lirc-x liblircclient0 
	sudo dpkg-reconfigure lirc
}


function MDLBLLST ()									# Blacklisting wrong module
{
	sudo chmod 666				   /etc/modprobe.d/blacklist.conf
	echo "# X10 Remote Control"		>> /etc/modprobe.d/blacklist.conf
	echo blacklist ati_remote 		>> /etc/modprobe.d/blacklist.conf
	sudo chmod 644				   /etc/modprobe.d/blacklist.conf
}


function ADDM2RCL ()
{
	sudo chmod 777				   /etc/rc.local
	echo "# Loading X10 Remote modules"	>> /etc/rc.local			# Loading module for transmitterreciever
	echo "sudo modprobe lirc_dev"		>> /etc/rc.local
	echo "sudo modprobe lirc_atiusb"	>> /etc/rc.local
	echo "sudo /etc/init.d/lirc start"	>> /etc/rc.local
	sudo chmod 755				   /etc/rc.local
}

function CPF ()										# Copy configfiles
{
	sudo mkdir -p		/etc/lirc/
	     mkdir -p		$HOME/.xbmc/userdata/keymaps	
	sudo cp hardware.conf 	/etc/lirc/hardware.conf
	sudo cp lircd.conf 	/etc/lirc/lircd.conf
	     cp Lircmap.xml 	$HOME/.xbmc/userdata/Lircmap.xml
	     cp Keyboard.xml	$HOME/.xbmc/userdata/keymaps/Keyboard.xml
}

###########################
## Installerscript start ##
###########################

echo											# Define script start parameters
	if [ `whoami` == "root" ] ; then
		echo
		echo "You Are Root - Please start Script as user"
		echo		
		exit
	else
		echo "You are not working as root - fine :)"
		echo	
	fi
 
											# Looking for blacklisted module 
echo
	if   [ "$ATIBL" == "yes" ] ; then
		echo
		echo "ati_remote module already blacklisted - nothing to do"
		echo

	elif [ "$ATIBL" == "no"  ] ; then
		echo	
		echo " Blacklisting ati_remote module in /etc/modprobe.d/blacklist.conf "
		MDLBLLST 	
	else	
		echo " Cant get information - is the modul ati_remote blacklisted in "
		echo " /etc/modprobe.d/blacklist.conf "
		echo " Please check manually "	
		exit
	fi

echo
#	if   [ "$RMRCL" == "yes" ] ; then
#		echo
#		echo "Autoload by rc.loacal already exist"
#		echo
#
#	elif [ "$RMRCL" == "no"  ] ; then
#		echo	
#		echo " Adding autoload by rc.local "
#		ADDM2RCL 	
#	else	
#		echo " Cant get information -"
#		echo " Please check manually "	
#		exit
#	fi



echo
echo "============================================="
echo "===== X 10 Remote Software installation ====="
echo "============================================="
echo 
echo -n "Install Remote Software  ? Y/N "
proceed=
read -t 5 -n 1 proceed
	if   [ "$proceed" == "y" -o "$proceed" == "Y" ] ; then 
		echo		
		LIRCINST

	elif [ "$proceed" == "n" -o "$proceed" == "N" ] ; then
		echo
		echo			
		echo "X 10 Remote Software installation not started"
	else
		echo
		echo
		echo "No or wrong Input - continue with No"
		echo
	fi



echo
echo "==========================================="
echo "===== Copy X 10 Remote Configuration  ====="
echo "==========================================="
echo 
echo -n "Copy Remote Configuration  ? Y/N "
proceed=
read -t 5 -n 1 proceed
	if   [ "$proceed" == "y" -o "$proceed" == "Y" ] ; then 
		echo		
		CPF
		echo
		echo " X 10 Remote Configuration copied "
		echo

	elif [ "$proceed" == "n" -o "$proceed" == "N" ] ; then
		echo
		echo			
		echo "X 10 Remote Configuration not copied"
		echo
	else
		echo
		echo
		echo "No or wrong Input - continue with Yes"
		echo
		CPF
		echo " X 10 Remote Configuration copied "
		echo
	fi



sudo /etc/init.d/lirc restart
